package main;

import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;

public class IOFactory {

	static JScrollPane getScrollPane(JComponent component) {
		JScrollPane pane = new JScrollPane(component);
		pane
				.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		pane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		return pane;
	}

	static JPanel getPanelForButton(JButton... buttons) {
		JPanel panel = new JPanel(new GridLayout(1, buttons.length, 5, 5));
		for (int i = 0; i < buttons.length; i++) {
			panel.add(buttons[i]);
		}
		JPanel paneRet = new JPanel(new FlowLayout());
		paneRet.add(panel);
		return paneRet;
	}

	static JPanel getPane(JComponent comp) {
		JPanel panel = new JPanel(new FlowLayout());
		panel.add(comp);
		return panel;
	}

	static JPanel getVerticalPane(List<JRadioButton> buttons) {
		JPanel panel = new JPanel(new GridLayout(buttons.size(), 1, 5, 5));
		for (int i = 0; i < buttons.size(); i++) {
			panel.add(buttons.get(i));
		}
		JPanel paneRet = new JPanel(new FlowLayout());
		paneRet.add(panel);
		return paneRet;
	}

	static List<String> findAllTems() {
		File file = new File("topic.txt");
		FileInputStream fis = null;
		try {
			fis = new FileInputStream(file);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		BufferedInputStream bis = new BufferedInputStream(fis);
		Scanner sc = new Scanner(bis);

		List<String> list = new ArrayList<String>();

		while (sc.hasNext()) {
			list.add(sc.nextLine());
		}
		try {
			fis.close();
			bis.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return list;
	}

	static String findTextByShow(String temaName) {
		File file = null;
		FileInputStream fis = null;

		String buf = "";

		try {
			file = new File("Info/" + temaName.substring(10, temaName.length())
					+ ".txt");
			fis = new FileInputStream(file);
		} catch (FileNotFoundException e) {
			try {
				file = new File("Info/" + temaName + ".txt");
				fis = new FileInputStream(file);
			} catch (FileNotFoundException e1) {
				error();
				e1.printStackTrace();
			}
		}

		Scanner sc = new Scanner(fis);

		while (sc.hasNext()) {
			buf += sc.nextLine() + '\n';
		}

		return buf;
	}

	static List<Test> findTestByTema(String temaName) {
		List<Test> list = new ArrayList<Test>();

		File file = null;
		FileInputStream fis = null;

		try {
			file = new File("Tests/"
					+ temaName.substring(10, temaName.length()) + ".txt");
			fis = new FileInputStream(file);
		} catch (FileNotFoundException e) {
			try {
				file = new File("Tests/" + temaName + ".txt");
				fis = new FileInputStream(file);
			} catch (FileNotFoundException e1) {
				error();
				e1.printStackTrace();
			}
		}

		Scanner sc = new Scanner(fis);

		while (sc.hasNext()) {
			Test test = new Test();
			List<String> lis = new ArrayList<String>();
			
			String buffer = sc.nextLine();
			String bufEnd = "";
			
			for(int i = 0; i<buffer.length();i++){
				if(buffer.charAt(i) == '^'){
					bufEnd += '\n';
				}else bufEnd += buffer.charAt(i);
			}
			
			test.setQuestion(bufEnd);

			String str = sc.nextLine();
			char ch = str.charAt(0);

			while (sc.hasNext() && !(str = sc.nextLine()).equals("")) {
				lis.add(str);
				if (str.charAt(0) == ch) {
					test.setAnswer(str);
				}
			}
			test.setAnswerList(lis);
			list.add(test);
		}

		return list;
	}

	static String getTextOnInfoPane() {
		File file = new File("about.txt");
		FileInputStream fis = null;
		try {
			fis = new FileInputStream(file);
		} catch (FileNotFoundException e) {
			error();
			e.printStackTrace();
		}
		BufferedInputStream bis = new BufferedInputStream(fis);
		Scanner sc = new Scanner(bis);

		StringBuilder sb = new StringBuilder();

		while (sc.hasNext()) {
			sb.append(sc.nextLine());
			sb.append("\n");
		}
		try {
			fis.close();
			bis.close();
		} catch (IOException e) {
			error();
			e.printStackTrace();
		}
		return sb.toString();
	}

	static String findInfoByTema(String tem) {
		return "sdfdfgsdf ";
	}

	public static String getName() {
		File file = new File("Name.txt");
		FileInputStream fis = null;
		try {
			fis = new FileInputStream(file);
		} catch (FileNotFoundException e) {
			error();
			e.printStackTrace();
		}
		BufferedInputStream bis = new BufferedInputStream(fis);
		Scanner sc = new Scanner(bis);
		return sc.nextLine();
	}

	public static void error() {
		JOptionPane.showMessageDialog(null, "database error", "error",
				JOptionPane.ERROR_MESSAGE);
		System.exit(1);
	}

	public static boolean is(String nameFile) {
		File file = new File(nameFile);
		return file.isFile();
	}
}
