package main;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableModel;

public class TemaPanel extends JPanel implements ListSelectionListener{

	private JButton selectButton, infoButton;
	private JTable table;
	private DefaultTableModel model;
	private List<String> temList;
	private StartClass controller;
	
	public TemaPanel(StartClass _controller) {
		super();
		
		controller = _controller;
		temList = IOFactory.findAllTems();
		Object[][] dataMasive = new Object[temList.size()][1];
		
		for(int i = 0;i<temList.size();i++){
			dataMasive[i][0] = temList.get(i);
		}
		
		model = new DefaultTableModel(dataMasive, new String[] {"names so"}){
			public boolean isCellEditable(int rowIndex, int columnIndex) {
                return false;
            }
		};
		table = new JTable(model);
		
		table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		table.getSelectionModel().addListSelectionListener(this);
		
		selectButton = new JButton("Test");
		selectButton.setEnabled(false);
		selectButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				if(getSelectTem() != null){
					controller.showTests(getSelectTem());
				}
			}
		});
		
		infoButton = new JButton("info");
		infoButton.setEnabled(false);
		infoButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				if(getSelectTem() != null){
					controller.showInfo(getSelectTem());
				}
			}
		});
		
		setLayout(new BorderLayout(5, 5));
		setBorder(new EmptyBorder(5, 5, 5, 5));
		
		add(IOFactory.getScrollPane(table), BorderLayout.CENTER);
		add(IOFactory.getPane(new JLabel("Select topic")),BorderLayout.NORTH);
		add(IOFactory.getPanelForButton(infoButton, selectButton),BorderLayout.SOUTH);
	}
	
	protected String getSelectTem(){
		int tabsel = table.getSelectedRow();
		if(tabsel < 0){
			return null;
		}
		int modsel = table.convertRowIndexToModel(tabsel);
		if(modsel < 0){
			return null;
		}
		return temList.get(modsel);
	}

	public void valueChanged(ListSelectionEvent e) {
		if(getSelectTem() != null){
			if(IOFactory.is("Tests/" + getSelectTem().substring(10, getSelectTem().length()) + ".txt") ||
					IOFactory.is("Tests/" + getSelectTem() + ".txt")){
				selectButton.setEnabled(true);
			}else selectButton.setEnabled(false);
			
			if(IOFactory.is("Info/" + getSelectTem().substring(10, getSelectTem().length()) + ".txt") ||
					IOFactory.is("Info/" + getSelectTem() + ".txt")){
				infoButton.setEnabled(true);
			}else infoButton.setEnabled(false);
		}

	}
}
