package main;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextArea;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;

public class TestPanel extends JPanel{
	
	protected List<Test> testsList;
	protected Integer[] otvets;
	
	private JButton butNext, butPrev, butSend;
	
	protected Boolean[] boolList;
	
	private JTextArea questionArea;
	private List<JRadioButton> buttonList;
	
	private ButtonGroup groupButton;
	private JPanel panelVariant;
	
	private StartClass controller;
	
	private JPanel content;
	
	private Test currentTest;
	private int currentTestNumber;
	
	public TestPanel(StartClass _controller) {
		super();
		
		controller = _controller;
		
		content = new JPanel();
		content.setLayout(new GridLayout(2, 1));
		
		setLayout(new BorderLayout(5, 5));
		setBorder(new EmptyBorder(5, 5, 5, 5));
		
		questionArea = new JTextArea();
		questionArea.setEditable(false);
		questionArea.setLineWrap(true);
		questionArea.setBorder(new TitledBorder("Question"));
		
		panelVariant = new JPanel();
		panelVariant.setLayout(new BorderLayout(5, 5));
		
		butNext = new JButton("Next");
		butNext.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				nextTest();
			}
		});
		
		butPrev = new JButton("Prev");
		butPrev.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				prevTest();
			}
		});
		
		butSend = new JButton("Send");
		butSend.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				sendTest();
			}
		});
		
		content.add(questionArea, BorderLayout.NORTH);
		content.add(panelVariant);
		
		add(content, BorderLayout.CENTER);
		add(IOFactory.getPanelForButton(butPrev, butSend, butNext), BorderLayout.SOUTH);
		
		
		
		testsList = IOFactory.findTestByTema(controller.getTema());
		otvets = new Integer[testsList.size()];
		boolList = new Boolean[testsList.size()];
		for(int i = 0;i<testsList.size();i++){
			otvets[i] = -1;
			boolList[i] = false;
		}
		
		
		setTest(testsList.get(0), 0);
		
	}

	public void nextTest(){
		updateData();
		setTest(testsList.get(currentTestNumber + 1), currentTestNumber + 1);
		loadData();
		repaint();
	}
	
	public void prevTest(){
		updateData();
		setTest(testsList.get(currentTestNumber - 1), currentTestNumber - 1);
		loadData();
		repaint();
	}
	
	public void sendTest(){
		updateData();
		controller.showResult(testsList, boolList);
		
	}
	
	/**     */
	protected void updateData(){
		for(int i = 0;i<buttonList.size();i++){
			if(buttonList.get(i).isSelected()){
				otvets[currentTestNumber] = i;
				if(currentTest.getAnswer().equals(buttonList.get(i).getText())){
					boolList[currentTestNumber] = true;
				}else boolList[currentTestNumber] = false;
			}
		}
	}
	
	/**   */
	protected void loadData(){
		if(otvets[currentTestNumber] != -1){
			buttonList.get(otvets[currentTestNumber]).setSelected(true);
		}
	}
	
	protected void setTest(Test _test, int number){
		currentTest = _test;
		currentTestNumber = number;
		
		butPrev.setEnabled(true);
		butNext.setEnabled(true);
		
		if(currentTestNumber == 0){
			butPrev.setEnabled(false);
		}
		if(currentTestNumber == testsList.size()-1){
			butNext.setEnabled(false);
		}
		
		questionArea.setText(_test.getQuestion());
		
		panelVariant.removeAll();
		
		groupButton = new ButtonGroup();
		buttonList = new ArrayList<JRadioButton>();
		
		for(int i = 0;i<_test.getAnswerList().size();i++){
			JRadioButton r = new JRadioButton(_test.getAnswerList().get(i));
			groupButton.add(r);
			buttonList.add(r);
		}
		
		panelVariant.add(IOFactory.getVerticalPane(buttonList), BorderLayout.WEST);
		panelVariant.revalidate();
		
		
	}

	
}
